unit U_FDTD_Zela;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Math, Jpeg,convlvdrv
  ;

Const
  natah = 2;
  eps0 = (1e-9)/(36*pi);                 //...........epsilon nula
  epsr_koax = 1;
                       //...........epsilon er dielektrika koaxialniho kabelu
  //epsr_disk = 1                        //...........epsilon er dielektrika diskontinuity, ktera je pres cely prurez dielektrika koaxu
  mu0  = 4e-7 * pi;                      //...........mi nula
  cs = 3e8;                        //...........rychlost svetla

  Emax=85000;                               //...........Emax budici vlny
  nmaX = 1990*natah;                           //...........pocet bodu diskretizacni site v podelnem smeru
//  MAXY = 100;                            //...........pocet bodu diskretizacni site v pricnem smeru
  BUZENI_X = 130*natah;                        //...........vzdalenost buzeni v diskretizacni siti
  i1 = 400*natah;                    //...........vzdalenost 1. rozhrani diskontinuity (je umistena)

  delta_z = 0.0001/natah;                     //...........vypocet delta z
  delta_t = (delta_z/cs)/2;              //...........vypocet delta t
  m = 0;                                 //...........vzdy nula
  ITERACI = 256*64;                       //...........pocet iteraci

  OffsetY = 230;                         //...........pomocne konstanty pro grafiku
  Obr_X  =  993;                        //940
  Obr_Y = 800;                         //600
  SONDA_Y = 30;                         //............poloha sondy (0..MAXY)
  NORM = 300;                           //............normovaci konstanta pro Er,Hfi,Hz

var timp:real;

type
    TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    GroupBox2: TGroupBox;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    RadioButton14: TRadioButton;
    GroupBox3: TGroupBox;
    RadioButton15: TRadioButton;
    RadioButton16: TRadioButton;
    RadioButton17: TRadioButton;
    RadioButton18: TRadioButton;
    RadioButton19: TRadioButton;
    RadioButton20: TRadioButton;
    RadioButton21: TRadioButton;
    RadioButton22: TRadioButton;
    RadioButton23: TRadioButton;
    RadioButton24: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FDTD_OneIteration;
    procedure Ukaz_Pole;
  private
    { Private declarations }
  public
    { Public declarations }
    Obrazovka: TBitmap;
  end;

type
  TMatrix = array[0..nmaX] of real;
  prubeh = array[0..iteraci-1] of extended;

var
  Form1: TForm1;
  E,H : TMatrix;
  Z : real;
  time: real = 0;
  magn,el1,el2,el3,kapsae,kapsae2,kapsam,kapsam2,dampe,ezh1,ezh2, Zv : real;
  epsr : real;
  jednou:integer=0;
  mmm,i2,sila:integer;
  sigma:extended;
  nit,nitr:integer;

  Ebuzeni,Erefl,Eskrz,Epred,Ezpet:prubeh;

implementation

{$R *.DFM}

procedure Konstanty;
var i:integer;
begin
  MAGN := delta_t/mu0/delta_z;
  EL1 := delta_t/delta_z/eps0;
  EL2 := delta_t/delta_z/eps0/epsr;
  EL3 := delta_t*sigma/eps0/epsr;
  dampe:=(1-sigma*delta_t/2/eps0/epsr)* (1+sigma*delta_t/2/eps0/epsr);
  EzH2:=delta_t/eps0/epsr/delta_z/(1+sigma*delta_t/2/eps0/epsr);
  EzH1:=delta_t/eps0/delta_z;
  for i:=0 to iteraci-1 do Ebuzeni[i]:=0;
  Erefl:=Ebuzeni;Eskrz:=Ebuzeni;Epred:=Ebuzeni;Ezpet:=Ebuzeni;
  nit:=0;
end;

procedure upravVlny;
// Procedura odlisi postupnou a zpetnou vlnu na vstupu
var i:integer;
begin
for i:=0 to iteraci-1 do Ebuzeni[i]:=0;
  Ezpet:=Ebuzeni;
  for i:= 8 to iteraci do begin
      Ebuzeni[i]:=Erefl[i-2];//nehotove
      end;
end;

function Black_har(tt:real):real;
const
  c0 = 0.35875;
  c1 = 0.48829;
  c2 = 0.14128;
  c3 = 0.01168;
var t :real;
begin
  t:=tt-timp/2;
  Black_har:=0;
  if tt <= timp then Black_Har:=c0+c1*cos(2*pi*t/timp)+c2*cos(4*pi*t/timp)+c3*cos(6*pi*t/timp);
end;

procedure TForm1.FDTD_OneIteration;
var i,j : integer;

begin
  //buzeni
 if time<1.25*timp
    then
      begin
           E[buzeni_x]:=E[buzeni_x]+Emax*Black_Har(time);
   //        H[BUZENI_x] := E[BUZENI_x]/Zv;
      end;


 //if jednou<30 then E[buzeni_x]:=2000;
 inc(jednou);

 inc(nit);
 // odeberu vzorky signalu
 if nit > i1-buzeni_x then  begin
    nitr:=nit-i1+buzeni_x;
    Erefl[nitr]:=E[i1-2];
    Epred[nitr]:=E[i1-1];
    Eskrz[nitr]:=E[i2+1];
    end;
   time:=time+delta_t;

  // osetreni derivaci mezi dielektrikem a vodicem

  //vlastni iterace

  //prepocet E

  for i:=1 to i1-1 do e[i]:=e[i]-ezh1*(h[i]-h[i-1]);
  for i:= i1 to i2 do e[i]:=e[i]*dampe-ezh2*(h[i]-h[i-1]);
  for i:= i2+1 to nmax do e[i]:=e[i]-ezh1*(h[i]-h[i-1]);

  E[0]:=kapsae2;
  kapsae2:=kapsae;
  kapsae:=E[1];

  // prepocteni H
  for i:= 0 to nmax-1 do h[i]:=h[i]-magn*(e[i+1]-e[i]);
  h[nmax]:=kapsam2;
  kapsam2:=kapsam;
  kapsam:=h[nmax-1];

end;

procedure TForm1.FormCreate(Sender: TObject);
var i,j : integer;
begin
  Form1.Left:=0;
  Form1.Top:=0;

  Obrazovka := TBitmap.Create;
  Obrazovka.Width :=  Obr_X;
  Obrazovka.Height := Obr_Y;

      for j:=0 to nMAX do
        begin
          E[j]  := 0;
          H[j] := 0;
        end;
  Zv:=sqrt(mu0/eps0);

  //Zchar:=(138/sqrt(epsr_koax))*log10(r/r_stredni);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  halt;
end;

procedure TForm1.Ukaz_Pole;
var j : integer;
begin
  with Form1.Obrazovka.Canvas do
    begin
      Font.Name:='System';
      Font.Size:=15;
      Font.Style:=[fsBold];
      Font.Color:=clBlack;

      Brush.Color:= ClWhite;
      Pen.Color:= ClBlack;
      rectangle(10,10,1000,595);
      Pen.color:=ClRed;
      rectangle(20+round(i1/2/natah),10,20+round(i2/2/natah),595);
      Brush.Color:= ClGray;
      Pen.Color:= ClGray;

//      rectangle(round(DISK_START_X/2)+25,20,round(DISK_STOP_X/2)+25,500);


      Pen.color:=Clgreen;
      MoveTo(20,100+OffsetY);
          LineTo(20+(round(nMAX/2/natah))-2,100+OffsetY);
      Pen.Color:= ClBlack;
       Brush.Color:=  ClBlack;
      for j:=0 to ((round(nMAX/2/natah))-2) do
        begin
          MoveTo(j+20,100+OffsetY-round(E[j*2*natah]/NORM));
          LineTo(j+21,100+OffsetY-round(E[(j*2*natah)+2*natah]/NORM));
        end;

{      Brush.Color:=  ClRed;
      Pen.Color:= ClRed;
      for j:=0 to ((round(nMAX/2))-2) do
        begin
          MoveTo(j+20,80+OffsetY-round(120*pi*H[j*2]/NORM));
          LineTo(j+21,80+OffsetY-round(120*pi*H[(j*2)+2]/NORM));
        end;
      Brush.Color:=  ClGreen;
      Pen.Color:= ClGreen;
      for j:=0 to ((round(nMAX/2))-2) do
        begin
          MoveTo(j+20,60+OffsetY-round(E[j*2]/NORM));
          LineTo(j+21,60+OffsetY-round(E[(j*2)+2]/NORM));
        end;
        }
    end;
  Form1.Image1.Canvas.CopyRect(Rect(0,0,Obr_X,Obr_Y),Form1.Obrazovka.Canvas,Rect(0,0,Obr_X,Obr_Y));
end;

procedure TForm1.Button1Click(Sender: TObject);
var p: integer;
begin
  if RadioButton1.Checked  then  epsr := 1;
  if RadioButton2.Checked  then epsr := 2;
  if RadioButton3.Checked  then epsr := 4;
  if RadioButton4.Checked  then epsr := 8;
  if RadioButton5.Checked  then epsr := 16;

  if RadioButton6.Checked  then sigma := 0;
  if RadioButton7.Checked  then sigma := 1;
  if RadioButton8.Checked  then sigma := 2;
  if RadioButton9.Checked  then sigma := 4;
  if RadioButton10.Checked then sigma := 8;
  if RadioButton11.Checked then sigma := 16;
  if RadioButton12.Checked then sigma := 32;
  if RadioButton13.Checked then sigma := 64;
  if RadioButton14.Checked then sigma := 128;
//  if RadioButton24.Checked then sigma := 256;
//  if RadioButton25.Checked then sigma := 512;

  if RadioButton15.Checked then sila := 10;
  if RadioButton16.Checked then sila := 20;
  if RadioButton17.Checked then sila := 30;
  if RadioButton18.Checked then sila := 50;
  if RadioButton19.Checked then sila := 100;
  if RadioButton20.Checked then sila := 200;
  if RadioButton21.Checked then sila := 400;
  if RadioButton22.Checked then sila := 800;
  if RadioButton23.Checked then sila := 1200;
  if RadioButton23.Checked then sila := 5;
   i2:=i1+sila*natah;

  timp  := delta_t*220*sqrt(epsr);    {doba impulsu} //...........doba trvani impulsu v sekundach

  konstanty;
  for p:= 0 to ITERACI do
    begin
      FDTD_OneIteration ;
 //     for mmm:=1 to round(epsr)-2 do FDTD_OneIteration ;
      Ukaz_Pole;
      Application.ProcessMessages;
    end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  Ukaz_pole;
end;

end.

